/* Proiect PM 2018
 * Tabara Maria Teodora, 336CA
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "lcd.h"

#define BALL_INIT_X		6
#define BALL_INIT_Y		2
#define PLATF_INIT		2
#define END_SCORE		8
#define LEFT_MARGIN		1
#define RIGHT_MARGIN	14
#define UP_MARGIN		6
#define DOWN_MARGIN		1		
#define PRECISION		0.7
#define SPEED			1

void pick_random_direction(int *dirX, int *dirY) {  
	
	if (rand() % 2 == 0) 
	{
		*dirX = SPEED;
		*dirY = SPEED;
	}
	else
	{
		*dirX = -SPEED;
		*dirY = -SPEED;
	}
}

int check_ciocnire(int ball, int platform) {
	

	return (ball == platform || 
			ball == platform - PRECISION || 
			ball == platform + PRECISION);
}

void score_point(int *score, int *dirX, int *dirY) {
	
	(*score)++;
	(*dirX) *= (-1);
	(*dirY) *= (-1);
}

int main() {
	
	/* Directii traiectorie bila */
	int dirX = 0, dirY = 0;
	
	/* Pozitie bila*/
	int ballX = BALL_INIT_X, ballY = BALL_INIT_Y;
	
	/* Platforme player1, player2 */
	int platform1 = PLATF_INIT, platform2 = PLATF_INIT;
	
	/*Scor player1, player2*/
	int score1 = 0, score2 = 0;
	
	int finished = 0;
	
	/* Init LCD */
	lcd_init();
	lcd_contrast(0x50);	
	
	/* Ecran de start */
	lcd_goto_xy(6, 2);
	lcd_str("PONG");
	lcd_goto_xy(2, 3); 
	lcd_str("Tabara Maria");
	lcd_goto_xy(5, 5); 
	lcd_str("336CA");
	
	_delay_ms(3000000);
	
	/* Setup butoane - activeaza rezistentele de pull up */
	// Platforma player1
	DDRD &= ~(1 << PD0);
	DDRD &= ~(1 << PD1);

	// Platforma player2
	DDRD &= ~(1 << PD4);
	DDRD &= ~(1 << PD5);
	
	/* Prepare players */
	lcd_clear();
	lcd_goto_xy(5, 3);
	lcd_str("...3...");
	_delay_ms(50000);
	lcd_goto_xy(5, 3); 
	lcd_str("...2...");
	_delay_ms(50000);
	lcd_goto_xy(5, 3); 
	lcd_str("...1...");
	_delay_ms(50000);
	lcd_clear();
	lcd_goto_xy(7, 3); 
	lcd_str("GO!");
	_delay_ms(50000);
	
	/* Directii initiale minge */	
	pick_random_direction(&dirX, &dirY);
	
	while (!finished) {
		
		lcd_clear();	
		
		/* Desenare platforme */
		lcd_goto_xy(LEFT_MARGIN, platform1);
		lcd_chr(LINE);
		lcd_goto_xy(RIGHT_MARGIN, platform2);
		lcd_chr(LINE);
		lcd_goto_xy(5, 1);
		printf("%i - %i", score1, score2);
		
		/* Desenare minge */
		lcd_goto_xy(ballX, ballY);
		lcd_chr(BALL);
		
		/*Platforma player1 */
		
		// Buton directie in jos
		PORTD |= (1 << PD0);
		if ((PIND & (1 << PD0)) == 0) {
			
			if (platform1 < UP_MARGIN) {
				
				platform1++;
				lcd_goto_xy(LEFT_MARGIN, platform1);
				lcd_chr(LINE);
				
			}
		}
		
		// Buton directie in sus
		PORTD |= (1 << PD1);
		if ((PIND & (1 << PD1)) == 0) {
			
			if (platform1 > DOWN_MARGIN) {
				
				platform1--;
				lcd_goto_xy(LEFT_MARGIN, platform1);
				lcd_chr(LINE);
				
			}
		}
		
		/* Platforma player 2 */
		
		// Buton directie jos
		PORTD |= (1 << PD4);
		if ((PIND & (1 << PD4)) == 0) {
			
			if (platform2 < UP_MARGIN) {
				
				platform2++;
				lcd_goto_xy(RIGHT_MARGIN, platform2);
				lcd_chr(LINE);
				
			}
		}
		
		// Buton directie sus
		PORTD |= (1 << PD5);
		if ((PIND & (1 << PD5)) == 0) {
			
			if (platform2 > DOWN_MARGIN) {
				
				platform2--;
				lcd_goto_xy(RIGHT_MARGIN, platform2);
				lcd_chr(LINE);
				
			}
		}
		
		_delay_ms(2000);
		
		ballX += dirX;
		ballY += dirY;
		
		/* Desenare minge */
		if (ballX <= LEFT_MARGIN) {
			
			/* Ciocnire platforma player1 */
			
			if (check_ciocnire(ballY, platform1)){
				dirX *= (-1);
			
			/* Punct pentru player2 */
			} else {
				
				score_point(&score2, &dirX, &dirY);
			}
			
		} else if (ballX >= RIGHT_MARGIN) {
			
			/* Ciocnire platforma player2 */
			if (check_ciocnire(ballY, platform2)) {
				dirX *= (-1);
			
			/* Punct pentru player1 */
			} else {
				
				score_point(&score1, &dirX, &dirY);									
			}
		}
		
		if (ballY <= DOWN_MARGIN)
			dirY = SPEED;
		
		if (ballY >= UP_MARGIN) 
			dirY = -SPEED;
		
		/* Check if game finished */
		if(score1 == END_SCORE) {
					
			lcd_clear();
			lcd_goto_xy(2, 3);
			lcd_str("Player1 WON!");
			finished = 1;
			
		} else if(score2 == END_SCORE) {
					
			lcd_clear();
			lcd_goto_xy(2, 3);
			lcd_str("Player2 WON");
			finished = 1;
		}	
		
		_delay_ms(600);
		
	}
	
	return 0;
}


